<?php
# Format of XML file from V7000 (and/or SVC)
#
#Per-node Mdisk Statistics collected
# Taken from https://www-304.ibm.com/support/docview.wss?uid=ssg1S1003597&wv=1
#
#The abbreviation in brackets ()’s is the tag used within the XML file which the statistic is reported in.
#
#Per-node VDisk Statistics collected
#
#The abbreviation in brackets ( ) is the tag used within the XML file which the statistic is reported in.
#
#Note that the file on each node in the cluster will contain statistics only from those 
# Vdisks which are associated with the IO group that the node is a member of:
#
#   Vdisk id (idx)
#   Vdisk name (id)
#
#
#Per VDisk Read/write counters.
#
#    Per VDisk Read operations (ro)
#    Per VDisk Write operations (wo)
#    Per VDisk Read blocks (512 bytes) (rb)
#    Per VDisk Write blocks (512 bytes) (wb)
#
#There are much more counters available and documented at the above listed website.
#
# all required input parms
$hostname       	= $_SERVER["argv"][1];
$cmd            	= $_SERVER["argv"][2];
if (isset($_SERVER["argv"][3])) { $query_field = $_SERVER["argv"][3]; };
if (isset($_SERVER["argv"][4])) { $query_index = $_SERVER["argv"][4]; };


$xml_delimiter          =  "!";

exec("ls /svcmon/iostats/$hostname/Nv*|sort|tail -1", $output_arr);
$xml = simplexml_load_file("$output_arr[0]");

#foreach($xml->vdsk[0]->attributes() as $a => $b) {
    #echo $a,'="',$b,"\"\n";
#}

# This will output the index number of each vdsk
if ($cmd == "index") {
  foreach ($xml->children() as $node) {
    $arr = $node->attributes();   // returns an array
    print ($arr["idx"]."\n");     // get the value of this attribute
  }
}elseif ($cmd == "query") {
 foreach ($xml->children() as $node) {
    $arr = $node->attributes();   // returns an array
    if ($query_field == "index") { $query_field = "idx"; }
    print ($arr["idx"] . $xml_delimiter . $arr[$query_field] . "\n");     // get the value of this attribute
  }
}elseif ($cmd == "get") {
  if  ($query_field == "index") { $query_field = "idx"; }
  //print $xml->vdsk[(int)$query_index][$query_field] ;
  foreach ($xml->children() as $node) {
    //$arr = $node->attributes();   // returns an array
   // print_r($arr["wb"] );
   $currIndex = (int)$node->attributes()->idx; 
   //print $currIndex . " Q: " . $query_index . " F: " . $node->attributes()->wb . "\n";
    if ($currIndex == $query_index) { print $node->attributes()->$query_field; }
    //if ($arr["idx"]->idx = $query_index) { print ( $arr["rb"]  ); }
    //if ($arr["idx"] = $query_index) { print ( $arr["idx"]  ); }
    //print ($arr["idx"]."\n");     // get the value of this attribute
  }
}

?>
