<?php
# Format of XML file from V7000 (and/or SVC)
#
#Per-node General Statistics collected
# Taken from https://www-304.ibm.com/support/docview.wss?uid=ssg1S1003597&wv=1
#
# See URL above for information on what is available to monitor.

# all required input parms
$hostname       	= $_SERVER["argv"][1];
$cmd            	= $_SERVER["argv"][2];
if (isset($_SERVER["argv"][3])) { $query_field = $_SERVER["argv"][3]; };
if (isset($_SERVER["argv"][4])) { $query_index = $_SERVER["argv"][4]; };


$xml_delimiter          =  "!";

exec("ls /svcmon/iostats/$hostname/Nn*|sort|tail -1", $output_arr);
$xml = simplexml_load_file("$output_arr[0]");

# This will output the index number of each cpu. Since the v7000 XML 
#  file reports only one, we will just hard code the output.
if ($cmd == "index") {
  foreach ($xml->children()->node as $node) {
    $arr = $node->attributes();
    print(substr($node["node_id"], -1) . "\n");
  }
}elseif ($cmd == "query") {
 //if ($query_field == "index") { $query_field = "node_id"; }
 foreach ($xml->children()->node as $node) {
    $arr = $node->attributes();   // returns an array
    if ($query_field == "index") { 
      print (substr($node["node_id"], -1) . $xml_delimiter . substr($node["node_id"], -1) . "\n");  
    } else { 
      print (substr($node["node_id"], -1) . $xml_delimiter . $arr[$query_field] . "\n");  
    }
  }
}elseif ($cmd == "get") {
 if ($query_field == "index") { $query_field = "node_id"; }
  foreach ($xml->children()->node as $node) {
   $currIndex = substr($node->attributes()->node_id, -1); 
    if ($currIndex == $query_index) { print $node->attributes()->$query_field; }
 }
} 
?>
